scala.actors

# ReplyReactor

#### trait ReplyReactor extends Reactor[Any] with ReactorCanReply

Extends the Reactor trait with methods to reply to the sender of a message. Sending a message to a `ReplyReactor` implicitly passes a reference to the sender together with the message.

Source
  ReplyReactor.scala

Linear Supertypes
ReactorCanReply, CanReply[Any, Any], Reactor[Any], Combinators, OutputChannel[Any], AnyRef, Any
Known Subclasses
Actor, DaemonActor, SwingWorker
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. ReplyReactor
2. ReactorCanReply
3. CanReply
4. Reactor
5. Combinators
6. OutputChannel
7. AnyRef
8. Any

Visibility

1. Public
2. All

### Type Members

1. #### type Future[+P] = Future[P]

   Definition Classes
     ReactorCanReply → CanReply

### Abstract Value Members

1. #### abstract def act(): Unit

   The `ReplyReactor`'s behavior is specified by implementing this method.

   The `ReplyReactor`'s behavior is specified by implementing this method.

   Definition Classes
     Reactor

### Concrete Value Members

1. #### def !(msg: Any): Unit

   Sends `msg` to this `ReplyReactor` (asynchronous).

   Sends `msg` to this `ReplyReactor` (asynchronous).

   msg

     the message to send

   Definition Classes
     ReplyReactor → Reactor → OutputChannel

2. #### def !![A](msg: Any, handler: PartialFunction[Any, A]): Future[A]

   Sends `msg` to this `ReplyReactor` and immediately returns a future representing the reply value.

   Sends `msg` to this `ReplyReactor` and immediately returns a future representing the reply value. The reply is post-processed using the partial function `handler`. This also allows to recover a more precise type for the reply value.

   msg

     the message to be sent

   handler

     the function to be applied to the response

   returns

     the future

   Definition Classes
     ReactorCanReply → CanReply

3. #### def !!(msg: Any): Future[Any]

   Sends `msg` to this `ReplyReactor` and immediately returns a future representing the reply value.

   Sends `msg` to this `ReplyReactor` and immediately returns a future representing the reply value.

   msg

     the message to be sent

   returns

     the future

   Definition Classes
     ReactorCanReply → CanReply

4. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

6. #### def !?(msec: Long, msg: Any): Option[Any]

   Sends `msg` to this `ReplyReactor` and awaits reply (synchronous) within `msec` milliseconds.

   Sends `msg` to this `ReplyReactor` and awaits reply (synchronous) within `msec` milliseconds.

   msec

     the time span before timeout

   msg

     the message to be sent

   returns

     `None` in case of timeout, otherwise `Some(x)` where `x` is the reply

   Definition Classes
     ReactorCanReply → CanReply

7. #### def !?(msg: Any): Any

   Sends `msg` to this `ReplyReactor` and awaits reply (synchronous).

   Sends `msg` to this `ReplyReactor` and awaits reply (synchronous).

   msg

     the message to be sent

   returns

     the reply

   Definition Classes
     ReactorCanReply → CanReply

8. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

9. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

10. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

11. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

13. #### def continue(): Unit

    Continues with the execution of the closure registered as continuation following `andThen`.

    Continues with the execution of the closure registered as continuation following `andThen`. Continues with the execution of the next loop iteration when invoked inside the body of `loop` or `loopWhile`.

    Definition Classes
      Combinators

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def exceptionHandler: PartialFunction[Exception, Unit]

    This partial function is applied to exceptions that propagate out of this `ReplyReactor`'s body.

    This partial function is applied to exceptions that propagate out of this `ReplyReactor`'s body.

    Attributes
      protected[actors]
    Definition Classes
      Reactor

17. #### def exit(): Nothing

    Attributes
      protected[actors]
    Definition Classes
      Reactor

18. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

19. #### def forward(msg: Any): Unit

    Forwards `msg` to this `ReplyReactor` (asynchronous).

    Forwards `msg` to this `ReplyReactor` (asynchronous).

    msg

      the message to forward

    Definition Classes
      ReplyReactor → Reactor → OutputChannel

20. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

21. #### def getState: Value

    Returns the execution state of this `ReplyReactor`.

    Returns the execution state of this `ReplyReactor`.

    returns

      the execution state

    Definition Classes
      ReplyReactor → Reactor

22. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

23. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

24. #### def loop(body: ⇒ Unit): Unit

    Repeatedly executes `body`.

    Repeatedly executes `body`.

    body

      the block to be executed

    Definition Classes
      Combinators

25. #### def loopWhile(cond: ⇒ Boolean)(body: ⇒ Unit): Unit

    Repeatedly executes `body` while the condition `cond` is `true`.

    Repeatedly executes `body` while the condition `cond` is `true`.

    cond

      the condition to test

    body

      the block to be executed

    Definition Classes
      Combinators

26. #### def mailboxSize: Int

    Attributes
      protected[actors]
    Definition Classes
      Reactor

27. #### implicit def mkBody[A](body: ⇒ A): Body[A]

    Enables the composition of suspendable closures using `andThen`, `loop`, `loopWhile`, etc.

    Enables the composition of suspendable closures using `andThen`, `loop`, `loopWhile`, etc.

    Definition Classes
      Reactor → Combinators

28. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

29. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

30. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

31. #### def react(handler: PartialFunction[Any, Unit]): Nothing

    Receives a message from this `ReplyReactor`'s mailbox.

    Receives a message from this `ReplyReactor`'s mailbox.

    This method never returns. Therefore, the rest of the computation has to be contained in the actions of the partial function.

    handler

      a partial function with message patterns and actions

    Attributes
      protected[actors]
    Definition Classes
      ReplyReactor → Reactor

32. #### def reactWithin(msec: Long)(handler: PartialFunction[Any, Unit]): Nothing

    Receives a message from this `ReplyReactor`'s mailbox within a certain time span.

    Receives a message from this `ReplyReactor`'s mailbox within a certain time span.

    This method never returns. Therefore, the rest of the computation has to be contained in the actions of the partial function.

    msec

      the time span before timeout

    handler

      a partial function with message patterns and actions

    Attributes
      protected[actors]

33. #### def receiver: Actor

    Returns the `Actor` that is receiving from this `ReplyReactor`.

    Returns the `Actor` that is receiving from this `ReplyReactor`.

    Definition Classes
      Reactor → OutputChannel

34. #### def reply(msg: Any): Unit

    Replies with `msg` to the sender.

    Replies with `msg` to the sender.

    Attributes
      protected[actors]

35. #### def restart(): Unit

    Restarts this `ReplyReactor`.

    Restarts this `ReplyReactor`.

    Definition Classes
      Reactor
    Exceptions thrown
      java.lang.IllegalStateException

      if the `ReplyReactor` is not in state `Actor.State.Terminated`

36. #### def scheduler: IScheduler

    Attributes
      protected[actors]
    Definition Classes
      Reactor

37. #### def send(msg: Any, replyTo: OutputChannel[Any]): Unit

    Sends `msg` to this `ReplyReactor` (asynchronous) supplying explicit reply destination.

    Sends `msg` to this `ReplyReactor` (asynchronous) supplying explicit reply destination.

    msg

      the message to send

    replyTo

      the reply destination

    Definition Classes
      Reactor → OutputChannel

38. #### def sender: OutputChannel[Any]

    Returns the `ReplyReactor` which sent the last received message.

    Returns the `ReplyReactor` which sent the last received message.

    Attributes
      protected[actors]

39. #### def start(): Reactor[Any]

    Starts this `ReplyReactor`.

    Starts this `ReplyReactor`. This method is idempotent.

    Definition Classes
      Reactor

40. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

41. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

42. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

43. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

44. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from ReactorCanReply

### Inherited from CanReply[Any, Any]

### Inherited from Reactor[Any]

### Inherited from Combinators

### Inherited from OutputChannel[Any]

### Inherited from AnyRef

### Inherited from Any